searchData={"content_type":"text/markdown","items":[{"doc":"Core commands and types for ExIpfs.\nIn order for this module to work you need to have an IPFS daemon running. See README.md for details.","ref":"ExIpfs.html","title":"ExIpfs","type":"module"},{"doc":"iex> alias ExIpfs, as: Ipfs\n      iex> Ipfs.cat(\"QmZ4tDuvesekSs4qM5ZBKpXiZGun7S2CYtEZRB3DYXkjGx\")\n       >","ref":"ExIpfs.html#module-examples","title":"Examples - ExIpfs","type":"module"},{"doc":"Add a file to IPFS.","ref":"ExIpfs.html#add/2","title":"ExIpfs.add/2","type":"function"},{"doc":"* `data` - The data to be sent to the IPFS node.","ref":"ExIpfs.html#add/2-parameters","title":"Parameters - ExIpfs.add/2","type":"function"},{"doc":"https://docs.ipfs.tech/reference/kubo/rpc/#api-v0-add","ref":"ExIpfs.html#add/2-options","title":"Options - ExIpfs.add/2","type":"function"},{"doc":"Add a file to IPFS.\n\nhttps://docs.ipfs.tech/reference/kubo/rpc/#api-v0-add","ref":"ExIpfs.html#add_fspath/2","title":"ExIpfs.add_fspath/2","type":"function"},{"doc":"* `fspath` - The file system path to the file or directory to be sent to the node.","ref":"ExIpfs.html#add_fspath/2-parameters","title":"Parameters - ExIpfs.add_fspath/2","type":"function"},{"doc":"Only options deemed relevant are listed here. See the link above for the full list.\n```\n[\n  chunker: \"size-262144\", # Chunking algorithm, size-[bytes], rabin-[min]-[avg]-[max] or buzhash\n  cid-version: 0, # Defaults to 0 unless an option that depends on CIDv1 is passed. Passing version 1 will cause the raw-leaves option to default to true.\n  fscache: true, # Check the filestore for pre-existing blocks. (experimental)\n  hash: \"sha2-256\", # Hash function to use. Implies CIDv1 if not sha2-256. (experimental)\n  inline-limit: 32, # Maximum block size to inline. (experimental)\n  inline: false, # Inline small blocks into CIDs. (experimental).\n  only-hash: false, # Only chunk and hash - do not write to disk.\n  pin: true, # Pin locally to protect added files from garbage collection.\n  raw-leaves: false, # Use raw blocks for leaf nodes. (experimental)\n  to-files:  >, #  Add reference to Files API (MFS) at the provided path.\n  trickle: false, # Use trickle-dag format for dag generation.\n  wrap-with-directory: false, # Wrap files with a directory object.\n\n```","ref":"ExIpfs.html#add_fspath/2-options","title":"Options - ExIpfs.add_fspath/2","type":"function"},{"doc":"Get the contents of a file from ipfs.\nEasy way to get the contents of a text file for instance.","ref":"ExIpfs.html#cat/2","title":"ExIpfs.cat/2","type":"function"},{"doc":"https://docs.ipfs.tech/reference/kubo/rpc/#api-v0-cat\n```\n[\n  offset:  ,\n  length:  ,\n  progress:  \n]\n```","ref":"ExIpfs.html#cat/2-options","title":"Options - ExIpfs.cat/2","type":"function"},{"doc":"Get a file or directory from IPFS.\n\n*NB! Unsafe (relative symlinks) will raise an error.* This is a limitation of the underlying library.","ref":"ExIpfs.html#get/2","title":"ExIpfs.get/2","type":"function"},{"doc":"https://docs.ipfs.tech/reference/kubo/rpc/#api-v0-get\n```\n[\n  output:  , # Output to file or directory name. Optional, default:  \n  archive:  , # Output as a tarball. Optional, default: false\n  timeout:  , # Timeout in seconds. Optional, default: 100\n]\n```\nCompression is not implemented.\n\nIf you feel that you need more timeouts, you can use the `:timeout` option in the `opts` list.\nBut the default should be enough for most cases. More likely your content isn't available....","ref":"ExIpfs.html#get/2-options","title":"Options - ExIpfs.get/2","type":"function"},{"doc":"Show the id of the IPFS node.\n\nhttps://docs.ipfs.tech/reference/kubo/rpc/#api-v0-id\nReturns a map with the following keys:\n  - ID: the id of the node.\n  - PublicKey: the public key of the node.\n  - Addresses: the addresses of the node.\n  - AgentVersion: the version of the node.\n  - Protocols: the protocols of the node.","ref":"ExIpfs.html#id/0","title":"ExIpfs.id/0","type":"function"},{"doc":"List directory contents for Unix filesystem objects in IPFS.","ref":"ExIpfs.html#ls/2","title":"ExIpfs.ls/2","type":"function"},{"doc":"https://docs.ipfs.tech/reference/kubo/rpc/#api-v0-ls\n```\n[\n  headers:  , # Print table headers (Hash, Size, Name). Optional, default: false\n  resolve-type:  , # Resolve linked objects to find out their types. Optional, default: false\n  timeout:  , # Timeout in seconds. Optional, default: 100\n]\n```\n\nStreaming is not supported yet, but might be in there future. Post a feature request if you need it.","ref":"ExIpfs.html#ls/2-options","title":"Options - ExIpfs.ls/2","type":"function"},{"doc":"Ping a peer in the IPFS network.","ref":"ExIpfs.html#ping/4","title":"ExIpfs.ping/4","type":"function"},{"doc":"Resolve the value of names to IPFS.\n\nhttps://docs.ipfs.tech/reference/kubo/rpc/#api-v0-resolve","ref":"ExIpfs.html#resolve/2","title":"ExIpfs.resolve/2","type":"function"},{"doc":"```\n[\n  recursive: true,\n  nocache: true,\n  dht-record-count: 10,\n  dht-timeout: 10\n]\n```","ref":"ExIpfs.html#resolve/2-options","title":"Options - ExIpfs.resolve/2","type":"function"},{"doc":"A struct that represents the result of adding a file to IPFS.","ref":"ExIpfs.html#t:add_result/0","title":"ExIpfs.add_result/0","type":"type"},{"doc":"A struct for the ID returned by the id command.","ref":"ExIpfs.html#t:id/0","title":"ExIpfs.id/0","type":"type"},{"doc":"This struct is very simple. Some results are listed as \"Value\": size. This is a\nconvenience struct to make it easier match on the result.","ref":"ExIpfs.html#t:key_value/0","title":"ExIpfs.key_value/0","type":"type"},{"doc":"A struct for the links of a DAG in IPLD. When IPLD sees such a Key Value in the JSON result it will lookup the data.","ref":"ExIpfs.html#t:link/0","title":"ExIpfs.link/0","type":"type"},{"doc":"ExIpfs.MultibaseCodec is a struct representing a hash. Seems much like a codec structure to me, but hey. Things may differ.","ref":"ExIpfs.html#t:multi_codec/0","title":"ExIpfs.multi_codec/0","type":"type"},{"doc":"A Multihash.","ref":"ExIpfs.html#t:multi_hash/0","title":"ExIpfs.multi_hash/0","type":"type"},{"doc":"An object in IPFS with a hash and links to other objects.","ref":"ExIpfs.html#t:object/0","title":"ExIpfs.object/0","type":"type"},{"doc":"B58 encoded peer ID.","ref":"ExIpfs.html#t:peer_id/0","title":"ExIpfs.peer_id/0","type":"type"},{"doc":"A module that contains the functions that are used to interact with the IPFS API.","ref":"ExIpfs.Api.html","title":"ExIpfs.Api","type":"module"},{"doc":"A structured error returned from the upstream IPFS API.","ref":"ExIpfs.Api.html#t:error/0","title":"ExIpfs.Api.error/0","type":"type"},{"doc":"A an aggregate type that represents the possible errors that can be returned from the API.","ref":"ExIpfs.Api.html#t:error_response/0","title":"ExIpfs.Api.error_response/0","type":"type"},{"doc":"A type that represents the possible responses from the API.","ref":"ExIpfs.Api.html#t:response/0","title":"ExIpfs.Api.response/0","type":"type"},{"doc":"An http client to handle streaming data from the IPFS API.","ref":"ExIpfs.ApiStreamingClient.html","title":"ExIpfs.ApiStreamingClient","type":"module"},{"doc":"Starts a stream client and returns a reference to the client.","ref":"ExIpfs.ApiStreamingClient.html#new/4","title":"ExIpfs.ApiStreamingClient.new/4","type":"function"},{"doc":"- pid: The pid to stream the data to.\n- url: The url to stream the data from.\n- timeout: The timeout for the stream. Defaults to infinity.\n- query_options: A list of query options to add to the url.","ref":"ExIpfs.ApiStreamingClient.html#new/4-parameters","title":"Parameters - ExIpfs.ApiStreamingClient.new/4","type":"function"},{"doc":"ExIpfs.Cid is where the cid commands of the IPFS API reside.","ref":"ExIpfs.Cid.html","title":"ExIpfs.Cid","type":"module"},{"doc":"Convert to base32 CID version 1.","ref":"ExIpfs.Cid.html#base32/1","title":"ExIpfs.Cid.base32/1","type":"function"},{"doc":"https://docs.ipfs.tech/reference/kubo/rpc/#api-v0-cid-base32\n`cid` - The CID to convert to base32.","ref":"ExIpfs.Cid.html#base32/1-parameters","title":"Parameters - ExIpfs.Cid.base32/1","type":"function"},{"doc":"List available multibase encodings.","ref":"ExIpfs.Cid.html#bases/1","title":"ExIpfs.Cid.bases/1","type":"function"},{"doc":"List available CID codecs.","ref":"ExIpfs.Cid.html#codecs/1","title":"ExIpfs.Cid.codecs/1","type":"function"},{"doc":"https://docs.ipfs.tech/reference/kubo/rpc/#api-v0-cid-codecs\n\n`numeric`   - Show codec numeric code.\n`supported`   - Show only supported codecs.","ref":"ExIpfs.Cid.html#codecs/1-options","title":"Options - ExIpfs.Cid.codecs/1","type":"function"},{"doc":"Format and convert a CID in various useful ways.","ref":"ExIpfs.Cid.html#format/2","title":"ExIpfs.Cid.format/2","type":"function"},{"doc":"`cid` - The CID to format and convert.","ref":"ExIpfs.Cid.html#format/2-parameters","title":"Parameters - ExIpfs.Cid.format/2","type":"function"},{"doc":"https://docs.ipfs.tech/reference/kubo/rpc/#api-v0-cid-format\n`f`   - printf style format string. Default: `%s`.\n`v`   - CID version.\n`b`   - Multibase to display CID in.\n`mc`   - Multicodec.","ref":"ExIpfs.Cid.html#format/2-options","title":"Options - ExIpfs.Cid.format/2","type":"function"},{"doc":"List available Multihashes.","ref":"ExIpfs.Cid.html#hashes/1","title":"ExIpfs.Cid.hashes/1","type":"function"},{"doc":"https://docs.ipfs.tech/reference/kubo/rpc/#api-v0-cid-hashes\n\n`supported`   - Show only supported hashes.","ref":"ExIpfs.Cid.html#hashes/1-options","title":"Options - ExIpfs.Cid.hashes/1","type":"function"},{"doc":"A v1 CID. This is the new Base32 CID format, which is likely to last and is preferred.","ref":"ExIpfs.Cid.html#t:base32cid/0","title":"ExIpfs.Cid.base32cid/0","type":"type"},{"doc":"ExIpfs.Multibase is where the multibase commands of the IPFS API reside.","ref":"ExIpfs.Multibase.html","title":"ExIpfs.Multibase","type":"module"},{"doc":"","ref":"ExIpfs.Multibase.html#decode/1","title":"ExIpfs.Multibase.decode/1","type":"function"},{"doc":"Decode a multibase encoded string.","ref":"ExIpfs.Multibase.html#decode!/1","title":"ExIpfs.Multibase.decode!/1","type":"function"},{"doc":"`data` - Data to decode.","ref":"ExIpfs.Multibase.html#decode!/1-parameters","title":"Parameters - ExIpfs.Multibase.decode!/1","type":"function"},{"doc":"","ref":"ExIpfs.Multibase.html#encode/2","title":"ExIpfs.Multibase.encode/2","type":"function"},{"doc":"Encode a string to a multibase encoded string.","ref":"ExIpfs.Multibase.html#encode!/2","title":"ExIpfs.Multibase.encode!/2","type":"function"},{"doc":"`data` - File to encode.","ref":"ExIpfs.Multibase.html#encode!/2-parameters","title":"Parameters - ExIpfs.Multibase.encode!/2","type":"function"},{"doc":"`b` - Multibase encoding to use.","ref":"ExIpfs.Multibase.html#encode!/2-options","title":"Options - ExIpfs.Multibase.encode!/2","type":"function"},{"doc":"List available multibase encodings.","ref":"ExIpfs.Multibase.html#list/1","title":"ExIpfs.Multibase.list/1","type":"function"},{"doc":"prefix - Only list encodings with the given prefix.\n  numeric - Only list encodings with the given numeric code.","ref":"ExIpfs.Multibase.html#list/1-options","title":"Options - ExIpfs.Multibase.list/1","type":"function"},{"doc":"Transcode a multibase encoded string.\n\nhttps://docs.ipfs.io/reference/http/api/#api-v0-multibase-transcode","ref":"ExIpfs.Multibase.html#transcode/2","title":"ExIpfs.Multibase.transcode/2","type":"function"},{"doc":"`data` - Data to transcode.","ref":"ExIpfs.Multibase.html#transcode/2-parameters","title":"Parameters - ExIpfs.Multibase.transcode/2","type":"function"},{"doc":"`b` - Multibase encoding to use","ref":"ExIpfs.Multibase.html#transcode/2-options","title":"Options - ExIpfs.Multibase.transcode/2","type":"function"},{"doc":"A multibase codec.","ref":"ExIpfs.Multibase.html#t:codec/0","title":"ExIpfs.Multibase.codec/0","type":"type"},{"doc":"A multibase encoding.","ref":"ExIpfs.Multibase.html#t:encoding/0","title":"ExIpfs.Multibase.encoding/0","type":"type"},{"doc":"ExIpfs.Refs is where the commands to lookup references are defined.\n\nTo get a gist of the contents, try:\n```elixir\niex> ExIpfs.Refs.local()\n```","ref":"ExIpfs.Refs.html","title":"ExIpfs.Refs","type":"module"},{"doc":"Get a list of all local references.\n\nResponse is a list of ExIpfs.ref().","ref":"ExIpfs.Refs.html#local/0","title":"ExIpfs.Refs.local/0","type":"function"},{"doc":"Get a list of all references from a given path.","ref":"ExIpfs.Refs.html#refs/2","title":"ExIpfs.Refs.refs/2","type":"function"},{"doc":"https://docs.ipfs.tech/reference/kubo/rpc/#api-v0-refs","ref":"ExIpfs.Refs.html#refs/2-options","title":"Options - ExIpfs.Refs.refs/2","type":"function"},{"doc":"A ref as reported from the refs group of commands","ref":"ExIpfs.Refs.html#t:t/0","title":"ExIpfs.Refs.t/0","type":"type"}]}